Unit MLA1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLA1R1_p, MLA1R2_p, MLA1R3_p;

procedure MLA1R(var A :Array of Real; M :Integer; N :Integer;
                MA :Integer; NA :Integer; M1 :Integer;
                var M2 :Integer; M3 :Integer; var IFLAG :Integer;
                var IZROV :Array of Integer;
                var IPOSV :Array of Integer; var L1 :Array of Integer;
                var L2 :Array of Integer; var L3 :Array of Integer);

implementation

procedure MLA1R(var A :Array of Real; M :Integer; N :Integer;
                MA :Integer; NA :Integer; M1 :Integer;
                var M2 :Integer; M3 :Integer; var IFLAG :Integer;
                var IZROV :Array of Integer;
                var IPOSV :Array of Integer; var L1 :Array of Integer;
                var L2 :Array of Integer; var L3 :Array of Integer);
var
NL1,K,NL2,I,IR,N1,M11,KP,M12,IP,IS_,KH,K1,IM1,IP1 :Integer;
Q1,BMAX :Real;
const
EPS :Real = 1.0E-6;
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_10,_20,_30,_40,_50,_55,_60,_70,_80,_90,_100,_110,_120,_130,_140,
_150,_155,_160,_170,_180,_190,_195,_200,_210,_220,_230,_240,_250;
begin
IFLAG := 0;

for K:=1 to MA do
 begin
  L1[K-1] := 0;
  L2[K-1] := 0;
  L3[K-1] := 0;
 end;

if ( M = M1+M2+M3 )
 then goto _1;
IFLAG := 65;
goto _250;
_1:
if ( M1+M3 <> 0 ) 
 then goto _10;
IFLAG := 67;
goto _250;
_10:
NL1 := N;
for K:=1 to N do
 begin
  L1[K-1] := K;
  IZROV[K-1] := K;
_20:
 end;
NL2 := M;
for I:=1 to M do
 begin
  if ( A[(I+0)+0*MA] >= ZERO ) 
   then goto _30;
  IFLAG := 66;
  goto _250;
_30:
  L2[I-1] := I;
  IPOSV[I-1] := N+I;
_40:
 end;
if ( M2 = 0 ) 
 then goto _55;
for I:=1 to M2 do
 begin
  L3[I-1] := 1;
_50:
 end;
_55:
IR := 0;
N1 := N+1;
M11 := M1+1;
if ( M2+M3 = 0 ) 
 then goto _230;
IR := 1;
for K:=1 to N1 do
 begin
  Q1 := ZERO;
  for I:=M11 to M do
   begin
    Q1 := Q1+A[(I+0)+(K-1)*MA];
_60:
   end;
  A[(M+1)+(K-1)*MA] := -Q1;
_70:
 end;
_80:
MLA1R1(A,MA,NA,M+1,L1,NL1,0,KP,BMAX);
if ( BMAX <= EPS ) and ( A[(M+1)+0*MA] < -EPS ) 
 then goto _90;
if ( BMAX <= EPS ) and ( A[(M+1)+0*MA] <= EPS ) 
 then goto _100;
goto _150;
_90:
IFLAG := 68;
goto _250;
_100:
M12 := M1+M2+1;
if ( M12 > M ) 
 then goto _120;
for IP:=M12 to M do
 begin
  IP1 := IP;
  if ( IPOSV[IP-1] <> IP+N ) 
   then goto _110;
  MLA1R1(A,MA,NA,IP1,L1,NL1,1,KP,BMAX);
  if ( BMAX > ZERO ) 
   then goto _155;
_110:
 end;
_120:
IR := 0;
M12 := M12-1;
if ( M1+1 > M12 ) 
 then goto _230;
for I:=M11 to M12 do
 begin
  IM1 := I-M1;
  if ( L3[IM1-1] <> 1 ) 
   then goto _140;
  for K:=1 to N1 do
   begin
    A[(I+0)+(K-1)*MA] := -A[(I+0)+(K-1)*MA];
_130:
   end;
_140:
 end;
goto _230;
_150:
MLA1R2(A,M,N,MA,NA,L2,NL2,IP,KP,Q1);
if ( IP <> 0 ) 
 then goto _160;
IFLAG := 68;
goto _250;
_155:
IP := IP1;
_160:
MLA1R3(A,MA,NA,M+1,N,IP,KP);
if ( IPOSV[IP-1] < N+M1+M2+1 ) 
 then goto _195;
for K:=1 to NL1 do
 begin
  K1 := K;
  if ( L1[K-1] = KP ) 
   then goto _180;
_170:
 end;
_180:
NL1 := NL1-1;
for IS_:=K1 to NL1 do
 begin
  L1[IS_-1] := L1[IS_+0];
_190:
 end;
goto _200;
_195:
if ( IPOSV[IP-1] < N+M1+1 ) 
 then goto _220;
KH := IPOSV[IP-1]-M1-N;
if ( L3[KH-1] = 0 ) 
 then goto _220;
L3[KH-1] := 0;
_200:
A[(M+1)+(KP+0)*MA] := A[(M+1)+(KP+0)*MA]+ONE;
M2 := M+2;
for I:=1 to M2 do
 begin
  A[(I-1)+(KP+0)*MA] := -A[(I-1)+(KP+0)*MA];
_210:
 end;
_220:
IS_ := IZROV[KP-1];
IZROV[KP-1] := IPOSV[IP-1];
IPOSV[IP-1] := IS_;
if ( IR <> 0 ) 
 then goto _80;
_230:
MLA1R1(A,MA,NA,0,L1,NL1,0,KP,BMAX);
if ( BMAX <= ZERO ) 
 then goto _250;
MLA1R2(A,M,N,MA,NA,L2,NL2,IP,KP,Q1);
if ( IP <> 0 ) 
 then goto _240;
IFLAG := 67;
goto _250;
_240:
MLA1R3(A,MA,NA,M,N,IP,KP);
goto _220;
_250:
end;

end.
